package physics;
import java.util.*;
public class Answers {
	//static public ArrayList<String> variables = new ArrayList();
	//static public ArrayList<String> equations = new ArrayList();
	static public void clear(){
		//variables.clear();
		//equations.clear();

		answers.clear();
		additional_variables.clear();
		additional_equations.clear();
	}
	
	static public ArrayList<Answer> answers = new ArrayList();
	
	static ArrayList<String> get_equations(){
		ArrayList<String> equations = new ArrayList();
		for(Answer answer : answers){
			equations.add(answer.equation);
			equations.add(answer.equation_inverse);
		}
		equations.addAll(additional_equations);
		return equations;
	}
	static ArrayList<String> get_variables(){
		ArrayList<String> variables = new ArrayList();
		for(Answer answer : answers){
			variables.add(answer.answer_id);
			variables.add(answer.answer_id_inverse);
		}
		variables.addAll(additional_variables);
		return variables;
	}
	
	
	static public String select_answer(String results){
		String[] solutions = results.split("\n");

		// not inverse
		for(String solution : solutions){
			String variable = solution.split("=")[0].trim();
			String value = solution.split("=")[1].trim();
			
			if (variable.endsWith("_inverse"))
				continue;
			
			for(Answer answer : answers){
				if (variable.equals(answer.answer_id) && value.equals("0") || variable.equals(answer.answer_id) && value.equals("0.0") ){
					return "answer is " + variable;
				}
			}
		}
		
		
		// inverse
		for(String solution : solutions){
			String variable = solution.split("=")[0].trim();
			String value = solution.split("=")[1].trim();

			if (!variable.endsWith("_inverse"))
				continue;

			for(Answer answer : answers){
				if (variable.equals(answer.answer_id_inverse) && value.equals("0")){
					variable = variable.substring(0, variable.length()-8);
					return "answer is " + variable;
				}
			}
		}
		
		return "failed";
	}
	
	
	static ArrayList<String> additional_variables = new ArrayList();
	static ArrayList<String> additional_equations = new ArrayList();
	
	
	// ^߂ƂɁAӂƂ`FbN  2012-Jun-3
	static void prepare_select_equation_of_motion_of(String left){
		for(Answer answer : answers){
			String answer_id_left = answer.answer_id + "_left";
			additional_variables.add(answer_id_left);
			String equation_left = answer_id_left + " = " + left + " - " + answer.left;
			additional_equations.add(equation_left);
			
			answer.answer_id_left = answer_id_left;
			answer.equation_left = equation_left;
		}
	}
	
	static public String select_equation_of_motion_of(String results, String left){
		String[] solutions = results.split("\n");

		for(Answer answer : answers){
			// Ŝ[ŁAleft [ł̂W߂B
			String value = get_solution(solutions, answer.answer_id);
			String value_inverse = get_solution(solutions, answer.answer_id_inverse);
			String value_left = get_solution(solutions, answer.answer_id_left);
			
			if ((value.equals("0") || value_inverse.equals("0") ) && value_left.equals("0"))
				return "answer is " + answer.answer_id;
		}
		
		return "failed";
	}
	static public String get_solution(String[] solutions, String target_variable){
		for(String solution : solutions){
			String variable = solution.split("=")[0].trim();
			String value = solution.split("=")[1].trim();
			if (target_variable.equals(variable))
				return value;
		}
		return "";
	}
	
	
	
	
	
	
	
	
	
	
	
	/*
	static public String select_answer(String results){
		String[] solutions = results.split("\n");

		// not inverse
		for(String solution : solutions){
			String variable = solution.split("=")[0].trim();
			String value = solution.split("=")[1].trim();
			
			if (variable.endsWith("_inverse"))
				continue;
			
			for(String _variable : variables){
				if (_variable.equals(variable) && value.equals("0")){
					return "answer is " + variable;
				}
			}
		}
		
		
		// inverse
		for(String solution : solutions){
			String variable = solution.split("=")[0].trim();
			String value = solution.split("=")[1].trim();

			if (!variable.endsWith("_inverse"))
				continue;

			for(String _variable : variables){
				if (_variable.equals(variable) && value.equals("0")){
					variable = variable.substring(0, variable.length()-8);
					return "answer is " + variable;
				}
			}
		}
		
		return "failed";
	}
	*/
	
	
}
class Answer {
	String answer_id;
	String answer_id_inverse;

	String equation;
	String equation_inverse;
	
	String left;
	String right;
	
	String answer_id_left;
	String equation_left;
	
	public Answer(String answer_id, String left, String right){
		this.left = left;
		this.right = right;
		
		this.answer_id = answer_id;
		this.answer_id_inverse = answer_id+"_inverse";
		
		left = " ( " + left + " ) ";
		right = " ( " + right + " ) ";
		
		this.equation = answer_id + " = " + left + " - " + right;
		//this.equation_inverse = answer_id_inverse + " = " + left + " + " + right;
		this.equation_inverse = answer_id_inverse + " = " + left + " * " + left + " - " + right + " *  "+ right ;
		
	}
}