package physics;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.Point;
import java.util.ArrayList;

public class Arrow extends EdgeVisual {

	public Arrow(){
		super();
	}
	public Arrow(Vector2D v0, Vector2D v1){
		super(v0, v1);


	}
	public void set_default_properties(){
		properties.clear();
		//set_property("rel_force", "F"+id, true, true);	// constant!
		set_property("rel_force", "0", true, true);	// constant!
	}

	public String get_default_name(){
		return "arrow"+id;
	}
	public String get_name(){
		return "arrow";
	}

	
	
	
	double d = 10;
	public void paint(Graphics g){
		if (Vector2D.distance(v0, v1)==0)
			return;
		
		g.setColor(Color.black);
		
		drawLine(g, v0, v1);

		paint_arrowhead(g, v1, v0, d);
		
		
	}
	public void paint_bbox(Graphics g){
		g.setColor(Color.red);
		
		Vector2D x_vec = new Vector2D(v0, v1);
		x_vec.normalize();
		Vector2D y_vec = Vector2D.rotate90(x_vec);
		x_vec.multiply(3);
		y_vec.multiply(3);
		
		Vector2D c0 = Vector2D.subtract(Vector2D.subtract(v0,  x_vec), y_vec);
		Vector2D c1 = Vector2D.add(Vector2D.subtract(v0,  x_vec), y_vec);
		Vector2D c2 = Vector2D.add(Vector2D.add(v1,  x_vec), y_vec);
		Vector2D c3 = Vector2D.subtract(Vector2D.add(v1,  x_vec), y_vec);
		drawLine(g, c0, c1);
		drawLine(g, c1, c2);
		drawLine(g, c2, c3);
		drawLine(g, c3, c0);
		
	}
	
	

	
	public ArrayList<Node> get_nodes(){
		
		ArrayList<Node> nodes = new ArrayList();
		Node node0 = new Node(this, get_variable("rel_force")+ " * "+vec_x(v0), get_variable("rel_force")+ " * "+vec_y(v0), v0, "ep1(id"+id+")");
		System.out.println("Arrow node "+node0.force_name_x+" "+node0.force_name_y);
		nodes.add(node0);
		
		return nodes;

	}

	
	
	/*
	public ArrayList<String> get_free_variables(){
		ArrayList<String> variables = new ArrayList();
		variables.add(get_variable("force"));
		return variables;
	}
*/

	
}
