package physics;

import javax.swing.*;

import java.awt.Font;
import java.io.*;
public class ConsoleCanvas extends JTextPane implements ButtonsInterface{
	public static ConsoleCanvas consoleCanvas;
	public ConsoleCanvas(){
		consoleCanvas = this;

		this.setFont(new Font("Helvetica", Font.PLAIN, 20));
	}

	public void initializeButtons(Buttons buttons){
		buttons.addButton("clear");
		buttons.addButton("execute");
	}
	public void buttonPressed(String label){
		if (label.equals("clear")){
			MainPanel.mainPanel.visuals.clear();
			MainPanel.mainPanel.repaint();
			MainPanel.mainPanel.selected_visual = null;
			InputCanvas.inputCanvas.clear();
		}
		if (label.equals("execute")){
			
			Acceleration.clear();
			Core.clear();
			
			for(Visual visual : MainPanel.mainPanel.visuals)
				visual.set_default_properties();
			for(Mass mass: MainPanel.mainPanel.masses())
				mass.direction = null;
			Answers.clear();
			
			InputCanvas.inputCanvas.bounded_variables.clear();
			
			String text = InputCanvas.inputCanvas.getText();
			String[] lines = text.split("[\n\r]+");
			for(String line : lines){
				InputCanvas.inputCanvas.execute(line);
			}
			/*
			BufferedReader in = new BufferedReader(new StringReader(text));
			while(true){
				String line = in.readLine();
				if (line == null)
					break;
			}
			*/
		}
	}
}
