package physics;

import java.util.*;

public class Core {
	static boolean USE_MAXIMA = true;
	static public ArrayList<String> additional_variables = new ArrayList();
	static public ArrayList<String> additional_equations = new ArrayList();
	static public void clear(){
		additional_variables.clear();
		additional_equations.clear();
	}
	static public void equations(){
		ArrayList<String> equations = get_equations_qe();
		// String[] variables = get_free_variables(null);
		
		println("equations");
		for(String equation : equations)
			println(equation);
		
		//println("variables");
		//for(String variable : variables)
		//	println(variable);
		
		
		HashSet<String> bounded_variables = new HashSet();
		bounded_variables.addAll(Analyzer.bounded_variables);
		bounded_variables.addAll(InputCanvas.inputCanvas.bounded_variables);
		//bounded_variables.addAll(LF.bounded_variables);
		bounded_variables.add("g");
		println("variables");
		println(bounded_variables);


		
		
		

		
		HashSet<String> positive_variables = new HashSet();
		String[] names = {"weight", "length", "sfc", "cnst_spring"}; 
		for(Visual visual : MainPanel.mainPanel.visuals){
			for(String name : names){
			Property property = visual.get_property(name);
			if (property == null)
				continue;
			String label = property.label;
			if (contains(label, bounded_variables))
				positive_variables.add(label);
			}
		}
		positive_variables.add("g");
		println("positive variables");
		println(positive_variables);
	}
	static void println(String line){
		MainPanel.mainPanel.textCanvas.println(line);
	}
	static void println(Collection<String> labels){
		String line = "";
		for(String label : labels){
			if (line.length() > 0)
				line += ", ";
			line += label;
		}
		println(line);
	}
	
	

	
	
	static public ArrayList<String> get_equations_qe(){
		ArrayList<String> equations = get_equations();
		
		HashSet<String> visited = new HashSet();
		for(Visual visual : MainPanel.mainPanel.visuals){
			if (visual instanceof Arc){
				Arc arc = (Arc) visual;
				if (arc.label.length() == 0)
					continue;
				
				if (visited.contains(arc.label))
					continue;
				
				if (is_number(arc.label))
					continue;
					
				visited.add(arc.label);
				equations.add(arc.label + " > 0");
				equations.add(arc.label + " < Pi/2");
			}
		}
		return equations;
		
	}
	static boolean is_number(String label){
		String[] nums =  {"0","1","2","3","4","5","6","7","8","9"};
		for(String num : nums){
			if (label.startsWith(num))
				return true;
		}
		return false;
	}
	/*
	static public ArrayList<String> get_equations_maxima(){
		ArrayList<String> equations = get_equations();
		
		ArrayList<String> equations_maxima = new ArrayList();
		for(String equation : equations){
			equations_maxima.add(equation.replaceAll("Pi", "%pi").replaceAll("abs", ""));	
		}
		return equations_maxima;
	}
*/
	
	
	static public ArrayList<String> get_equations(){
		
		ArrayList<String> equations = new ArrayList();
		
		// println("--- force balance for each element ---");
		for(Visual visual : MainPanel.mainPanel.visuals){
			if (! (visual instanceof Tag)){
				equations.addAll(visual.get_equations());
			}
		}
		
		//System.out.println("connections "+MainPanel.mainPanel.connections.size());
		// println("--- force balance for each connection ---");
		for(Connection connection : MainPanel.mainPanel.connections){
			
			//System.out.println("  connection ");
			
			// force balance
			{
			String line_x = "";
			String line_y = "";
			for(Node node : connection.nodes){
				//System.out.println("    node "+node.visual.id);
				if (line_x.length()>0){
					line_x += " + ";
					line_y += " + ";
				}
				line_x += node.force_name_x;
				line_y += node.force_name_y;
			}
			line_x += " = 0";
			line_y += " = 0";

			equations.add(line_x);
			equations.add(line_y);
			}

			
			if (Acceleration.enabled){
				
				ArrayList<Node[]> node_pairs = get_all_node_pairs(connection.nodes);
				
				for(Node[] node_pair : node_pairs){
					Node node0 = node_pair[0];
					Node node1 = node_pair[1];
					if (node0.acceleration_x == null || node1.acceleration_x == null)
						break;
					
					equations.add(node0.acceleration_x + " = " + node1.acceleration_x);
					equations.add(node0.acceleration_y + " = " + node1.acceleration_y);
					
				}
				
				/*
				String line_x = "";
				String line_y = "";
				if (connection.nodes.size() != 2)
					continue;
				
				boolean invalid = false;
				for(Node node : connection.nodes){
					if (node.acceleration_x == null){
						invalid = true;
						break;
						
					}
						
					if (line_x.length()>0){
						line_x += " = ";
						line_y += " = ";
					}
					line_x += node.acceleration_x;
					line_y += node.acceleration_y;
				}
				
				if (invalid)
					continue;

				equations.add(line_x);
				equations.add(line_y);
				*/
			}
			
		}


		
		// remove "reaction"
		ArrayList<String> effective_equations = new ArrayList();
		for(String equation : equations){
			System.out.println(""+equation);
			if (! equation.contains("reaction"))
				effective_equations.add(equation);
		}
		

		effective_equations.addAll(Analyzer.angle_equations);
		
		effective_equations.addAll(additional_equations);
		
		return effective_equations;
		
		//String[] array = new String[effective_equations.size()];
		//return effective_equations.toArray(array);
		
	}
	static ArrayList<Node[]> get_all_node_pairs(ArrayList<Node> nodes){
		ArrayList<Node[]> pairs = new ArrayList();
		for(int i=0; i<nodes.size()-1; i++){
			for(int j=i+1; j<nodes.size(); j++){
				pairs.add(new Node[]{nodes.get(i), nodes.get(j)});
			}			
		}
		return pairs;
	}
	
	/*
	static public HashSet<String> get_all_variables(){
		HashSet<String> all_variables = new HashSet();

		for(Visual visual : MainPanel.mainPanel.visuals){
			HashSet<String> local_variables = get_all_variables(visual);
			
			for(String local_variable : local_variables){
				if (local_variable.equals("0"))
					continue;
				if (local_variable.equals("1"))
					continue;
				
				all_variables.add(local_variable);
				
			}
		}
	
		return all_variables;
	
	}
	*/
	static public ArrayList<String> get_free_variables(String target_variable){
		//ArrayList<String> variables = new ArrayList();
		ArrayList<String> free_variables = new ArrayList();

		for(Visual visual : MainPanel.mainPanel.visuals){
			//  ArrayList<String> local_variables = visual.get_free_variables();
			ArrayList<String> local_variables = get_free_variables(visual);
			
			for(String local_variable : local_variables){
				if (contains(local_variable, free_variables))
					continue;
				if (local_variable.equals("0"))
					continue;
				if (local_variable.equals("1"))
					continue;
				
				
				free_variables.add(local_variable);
				
			}
		}
		
		free_variables.addAll(additional_variables);
		
		
		if (target_variable != null && !contains(target_variable, free_variables))
			free_variables.add(target_variable);
		
	
		
		
		return free_variables;
		
		//String[] array = new String[free_variables.size()];
		//return free_variables.toArray(array);

	}
	static ArrayList<String> get_free_variables(Visual visual){
		ArrayList<String> free_variables = new ArrayList();
		for(Property property : visual.properties){
			if (!property.constant)
				free_variables.add(property.label);
		}
		return free_variables;
	}
	static HashSet<String> get_all_variables(Visual visual){
		HashSet<String> all_variables = new HashSet();
		for(Property property : visual.properties){
			all_variables.add(property.label);
		}
		return all_variables;
	}
	static boolean contains(String string, Collection<String> strings){
		for(String _string : strings){
			if (string.equals(_string))
				return true;
		}
		return false;
	}
	static public String solve(String target_variable){
		ArrayList<String> equations = get_equations();
		ArrayList<String> variables = get_free_variables(target_variable);

		equations.addAll(Answers.get_equations());
		variables.addAll(Answers.get_variables());
		
		//return naive_solve(equations, variables, target_variable);
		return advanced_solve(equations, variables, target_variable);
	}
	
	static public String advanced_solve(ArrayList<String> equations, ArrayList<String> variables, String target_variable){
		
		
		while(true){
			String result = naive_solve(equations, variables, target_variable);
			if (!result.equals("[overconstrained]") && !result.equals("[underconstrained]"))
				return result;

			int count = variables.size();
			
			System.out.println(result);
			
			if (result.equals("[overconstrained]")){
				// add free variables  "x" ƂĂ̂
				//HashSet<String> all_variables = get_all_variables();
				//ArrayList<String> suspiciouses = get_suspicious(all_variables);
				HashSet<String> suspiciouses = get_gap_labels();
				
				for(String suspicious : suspiciouses){
					if (!contains(suspicious, variables)){
						variables.add(suspicious);
						System.out.println("added "+suspicious+" to free variables.");
						break;
					}
				}
				
			}
			else if (result.equals("[underconstrained]")){
				// remove free variables   L0@ftHgł̓t[
				variables = remove(variables, "L");
			}

			if (count == variables.size())
				break;

		}
		
		return "failed";
	}
	static HashSet<String> get_gap_labels(){
		HashSet<String> gap_labels = new HashSet();
		for(Visual visual : MainPanel.mainPanel.visuals){
			if (visual instanceof Stick){
				Stick stick = (Stick) visual;
				gap_labels.addAll(stick.gap_labels);
			}
		}
		return gap_labels;
	}
	static ArrayList<String> get_suspicious(HashSet<String> all_variables){
		ArrayList<String> suspiciouses = new ArrayList();
		for(String variable : all_variables){
			if (variable.startsWith("x"))
				suspiciouses.add(variable);
		}
		return suspiciouses;
	}
	static ArrayList<String> remove(ArrayList<String> variables, String token){
		ArrayList<String> removed = new ArrayList();
		for(String variable : variables){
			if (variable.startsWith(token)){
				System.out.println("removed "+token+" from free variables.");
				continue;
			}
			removed.add(variable);
		}
		return removed;
	}

	
	/*
	static public String advanced_solve(ArrayList<String> equations, ArrayList<String> variables, String target_variable){
		{
		String result = naive_solve(equations, variables, target_variable);
		if (!result.equals("[overconstrained]") && !result.equals("[underconstrained]"))
			return result;
		}
		
		for(int i=0; i<equations.size(); i++){
			ArrayList<String> _equations = new ArrayList();
			_equations.addAll(equations);
			_equations.remove(i);
			String result = naive_solve(_equations, variables, target_variable);
			if (!result.equals("[overconstrained]") && !result.equals("[underconstrained]"))
				return result;
		}
		return "failed";
	}
	*/
	static String[] naive_solve_Maxima(ArrayList<String> equations,ArrayList<String> variables){
		ArrayList<String> equations_maxima = new ArrayList();
		for(String equation : equations){
			equations_maxima.add(equation.replaceAll("Pi", "%pi"));	
		}
		equations =  equations_maxima;

		
		String[] solutions = Maxima.solve(equations, variables);
		
		
		if (solutions != null)
		for(int i=0; i<solutions.length; i++){
			solutions[i] = solutions[i].replaceAll("%pi", "Pi");	
		}

		return solutions;
	}
	static public String naive_solve(ArrayList<String> equations,ArrayList<String> variables, String target_variable){
		
		String[] solutions;
		
		if (USE_MAXIMA)
			solutions = naive_solve_Maxima(equations, variables);
		else
			solutions = Maple.solve(equations, variables);
		
		
		
		if (solutions == null){
			return "[overconstrained]";
		}

		if (target_variable == null){
			String result = "";
			for(String solution: solutions){
				solution = solution.trim();
				result += solution + "\n";
			}			
			return result;
		}
		
		for(String solution: solutions){
			solution = solution.trim();

			System.out.println(solution);
			if (get_variable_name(solution).equals(target_variable)){
				if (solution.contains("%"))
					return "[underconstrained]";
				return solution;
			}
		}
		return null;
	}
	static String get_variable_name(String solution){
		if (USE_MAXIMA){
			StringTokenizer st = new StringTokenizer(solution, " ");// maxima
			return st.nextToken();
		}
		else {
			StringTokenizer st = new StringTokenizer(solution, "=");// maple
			return st.nextToken();
		}
	}
	
}
