package physics;

import java.awt.Point;


public class Edge2D {
	public Vector2D start;
	public Vector2D end;

    Edge2D() {
    }	
    public Edge2D(Vector2D _start, Vector2D _end) {
	start = _start;
	end = _end;

    }	

    Edge2D(Point _start, Point _end) {
	start = new Vector2D(_start);
	end = new Vector2D(_end);
    }	

    public Vector2D get_the_other_vertex(Vector2D v){
	if (v==start) return end;
	else	return start;
    }


    // ƂČ_邩B
    static public boolean cross(Edge2D e0, Edge2D e1){
	return cross(
		e0.start.x,   e0.start.y,  e0.end.x,   e0.end.y,
		e1.start.x, e1.start.y, e1.end.x, e1.end.y);
    }

    // ƂČ_邩B
    static public boolean cross(
		double x1,  double y1,  double x2,  double y2,
		double xx1, double yy1, double xx2, double yy2){

	  // a * x + b * y + c = 0
	  double a0, b0, c0,
        	 a1, b1, c1; 
	  a0 = y1 - y2; 
	  b0 = x2 - x1;
	  c0 = y2 * x1 - x2 * y1;
	  a1 = yy1 - yy2; 
	  b1 = xx2 - xx1;
	  c1 = yy2 * xx1 - xx2 * yy1;

	  if (((a0* xx1+b0* yy1+c0)*(a0* xx2+b0* yy2+c0)<= 0) &&
	      ((a1*  x1+b1*  y1+c1)*(a1*  x2+b1*  y2+c1)<= 0))
		return true;
	  else
		return false;
   }
    static public boolean cross(
    		Vector2D p1, Vector2D p2,
    		Vector2D q1, Vector2D q2){

    	return cross(p1.x, p1.y, p2.x, p2.y, q1.x, q1.y, q2.x, q2.y);
       }

    // as a segment
    static public Vector2D cross_point(Edge2D edge0, Edge2D edge1){
    	Vector2D cross_point = cross_point( edge0.start.x, edge0.start.y, edge0.end.x, edge0.end.y,
    										edge1.start.x, edge1.start.y, edge1.end.x, edge1.end.y);
    	if (cross_point == null)
    		return null;
    	
    	if (Vector2D.dot_product(new Vector2D(edge0.start, edge0.end), new Vector2D(edge0.start, cross_point))<0)
    		return null;
       	if (Vector2D.dot_product(new Vector2D(edge0.end, edge0.start), new Vector2D(edge0.end, cross_point))<0)
    		return null;
    	if (Vector2D.dot_product(new Vector2D(edge1.start, edge1.end), new Vector2D(edge1.start, cross_point))<0)
    		return null;
       	if (Vector2D.dot_product(new Vector2D(edge1.end, edge1.start), new Vector2D(edge1.end, cross_point))<0)
    		return null;
    	
    	
    	return cross_point;
    }
    
    
    // as infinite line
    static private Vector2D cross_point(
		double x1,  double y1,  double x2,  double y2,
		double xx1, double yy1, double xx2, double yy2){

	  // a * x + b * y + c = 0
	  double a0, b0, c0,
        	 a1, b1, c1; 
	  a0 = y1 - y2; 
	  b0 = x2 - x1;
	  c0 = y2 * x1 - x2 * y1;
	  a1 = yy1 - yy2; 
	  b1 = xx2 - xx1;
	  c1 = yy2 * xx1 - xx2 * yy1;

	    if (Math.abs(a0 * b1 - a1 * b0) < 0.0001){
		return null;
	    }
	  
	    double x = ((b0 * c1 - b1 * c0)/(a0 * b1 - a1 * b0)) ;
	    double y = ((a0 * c1 - a1 * c0)/(a1 * b0 - a0 * b1));
	    return new Vector2D(x,y);

    }
    // as infinite line
    static public Vector2D cross_point(
    		Vector2D p1, Vector2D p2,
    		Vector2D q1, Vector2D q2){
    	return cross_point(p1.x, p1.y, p2.x, p2.y, q1.x, q1.y, q2.x, q2.y);
    }

    // ̉EB
    public boolean right_side_of_edge(
		double x1,  double y1,  double x2,  double y2,
		double x, double y){

	  // a * x + b * y + c = 0
	  double a0, b0, c0;

	  a0 = y1 - y2; 
	  b0 = x2 - x1;
	  c0 = y2 * x1 - x2 * y1;

	  //if (a0 * x + b0 * y+ c0 == 0)
	//	System.out.println("Vertex is on an Edge (Edge2D.right_side_of_edge)");
	  return ( a0 * x + b0 * y+ c0 < 0 );
    }



    // Skeleton Ŏgp
    public boolean equals(Vector2D v0, Vector2D v1){
	return (((v0==start)&&(v1==end))||((v1==start)&&(v0==end)));
    }
    public boolean contains(Vector2D v){
	return ((v == start) || (v == end));
    }
    public Vector2D vector2(){
	return new Vector2D(start, end);
    }
    public Vector2D mid_point(){
	return new Vector2D((start.x+end.x)/2, (start.y+end.y)/2);
    }
    public double length(){
	return Vector2D.distance(start, end);
    }

    public Vector2D get_common_vertex(Edge2D edge){
	if ((start == edge.start) || (start == edge.end))
		return start;
	else 
		return end;
    }


    /** ƂčlB */
    public double distance(Vector2D v){

  	  double a = end.x - start.x;
	  double b = end.y - start.y;

	  double bunbo = Math.sqrt(a * a + b * b);
	  double bunshi = a * (v.y - start.y) - b * (v.x - start.x);

	  if ( bunbo == 0 ) {
		System.out.println("Error in Edge2D.distance");
	       return 0;}
	  else {
	       return Math.abs(bunshi / bunbo);
	  }

    }	



   	/** ƂčlB */
	public double distance_as_a_segment (Vector2D node){
  
		Vector2D vec0 = new Vector2D(start, end);
		Vector2D vec1 = new Vector2D(start, node);
		if (Vector2D.dot_product(vec0, vec1) < 0){
		    return Vector2D.distance(node, start);
		};
		vec1 = new Vector2D(end, node);
		if (Vector2D.dot_product(vec0, vec1) > 0){
		    return Vector2D.distance(node, end);
		};
		
		return distance(node);
	
	}

	public Vector2D get_nearest_point(Vector2D p){
		Vector2D vec0 = new Vector2D(start, end);
		Vector2D vec1 = new Vector2D(start, p);
		if (Vector2D.dot_product(vec0, vec1) < 0){
		    return start;
		};
		vec1 = new Vector2D(end, p);
		if (Vector2D.dot_product(vec0, vec1) > 0){
		    return end;
		};
		
		//
		vec1 = new Vector2D(start, p);
		vec0.normalize();
		
		double l = Vector2D.dot_product(vec0, vec1);
		return Vector2D.add(start, Vector2D.multiply(vec0, l));
	}





	// 
	static public boolean touch(Edge2D edge, Vector2D v){
		return touch(v, edge);
	}
	static public boolean touch(Vector2D v, Edge2D edge){
		if (edge == null)
			return false;
		
		//Vector2D start_to_end = new Vector2D(edge.start, edge.end);
		//Vector2D start_to_v = new Vector2D(edge.start, v);
		
		//double l = start_to_end.length();
		double l = Math.sqrt((edge.end.x-edge.start.x)*(edge.end.x-edge.start.x)+
							 (edge.end.y-edge.start.y)*(edge.end.y-edge.start.y));
		
		//double distance = Math.abs(Vector2D.cross_product(start_to_end, start_to_v));
		double distance_by_l = Math.abs(Vector2D.cross_product(
				edge.end.x-edge.start.x, 	edge.end.y-edge.start.y,
				v.x-edge.start.x, 			v.y-edge.start.y));
		if (distance_by_l > 0.00001 * l)	// E-13// CONST 덷Ή
			return false;
		
		if (Vector2D.dot_product(
				edge.end.x-edge.start.x, 	edge.end.y-edge.start.y,
				v.x-edge.start.x, 			v.y-edge.start.y) 
				< -0.00001 *l)// CONST 덷Ή	// fixed 05_june_13
			return false;
		//Vector2D end_to_v = new Vector2D(edge.end, v);
		if (Vector2D.dot_product(
				edge.end.x-edge.start.x, 	edge.end.y-edge.start.y,
				v.x-edge.end.x, 			v.y-edge.end.y)
				> 0.00001 *l)// CONST 덷Ή// fixed 05_june_13
			return false;

		return true;
	}
}
