package physics;

import java.awt.Color;
import java.awt.Graphics;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.util.ArrayList;

public class Fixpoint extends Visual {
	public Vector2D v0;
	String label = "";

	public Fixpoint(){
		super();

	}
	public Fixpoint(Vector2D v0) {
		super();

		this.v0 = v0;

	}
	public void set_default_properties(){
		properties.clear();
		set_property("rel_force", "rel_force"+id, false, true);
	}
	public void save(BufferedWriter out){
		Record.write(out, "v0", v0);
	}
	public void load(BufferedReader in){
		v0 = Record.read_Vector2D(in);
	}
	
	

	public String get_default_name() {
		return "fixpoint" + id;
	}

	public String get_name() {
		return "fixpoint";
	}

	Vector2D prev_p = null;

	public void start_dragging(Vector2D p) {
		prev_p = p;
	}

	public void dragging(Vector2D p) {
		Vector2D vec = new Vector2D(prev_p, p);
		v0.add(vec);
		prev_p = p;
	}

	public void finish_dragging() {
		v0 = Tool.snap(v0);

	}

	int r = (int)Tool.d;/// 2;

	Vector2D v1;
	Vector2D v2;
	public void paint(Graphics g) {
		g.setColor(Color.black);
		
		v1 = new Vector2D(v0.x-r, v0.y+r*3);
		v2 = new Vector2D(v0.x+r, v0.y+r*3);

		int[] xs = { (int)v0.x, (int)v1.x, (int)v2.x};
		int[] ys = { (int)v0.y, (int)v1.y, (int)v2.y};
		g.fillPolygon(xs, ys, 3);
	}

	public void paint_bbox(Graphics g) {
		g.setColor(Color.red);

		
		int[] xs = { (int)v0.x, (int)v1.x-2, (int)v2.x+2};
		int[] ys = { (int)v0.y-2, (int)v1.y+2, (int)v2.y+2};
		g.drawPolygon(xs, ys, 3);

	}

	
	// tag 
	public double get_distance(Vector2D v) {
		v1 = new Vector2D(v0.x-r, v0.y+r*3);
		v2 = new Vector2D(v0.x+r, v0.y+r*3);
		
		Edge2D edge0 = new Edge2D(v0,v1);
		Edge2D edge1 = new Edge2D(v1,v2);
		Edge2D edge2 = new Edge2D(v1,v0);
		
		double d = min(edge0.distance_as_a_segment(v), edge1.distance_as_a_segment(v),edge2.distance_as_a_segment(v));
		return d - 10;
	}
	double min(double a,double b,double c){
		return Math.min(a, Math.min(b, c));
	}

	public void set_label(String label) {
		this.label = label;
	}

	public ArrayList<Node> get_nodes() {
		ArrayList<Node> nodes = new ArrayList();
		nodes.add(new Node(this, get_variable("reaction"), "(-1)*"+get_variable("rel_force"), v0, "ep1(id" + id + ")"));
		return nodes;
	}

	Friction friction;



}

