package physics;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.Point;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.util.ArrayList;

public class Gap extends EdgeVisual {
	
	public Gap(){
		super();

	}
	public Gap(Vector2D v0, Vector2D v1){
		super(v0,v1);

		this.v0 = v0;
		this.v1 = v1;
	}
	
	public void save(BufferedWriter out){
		Record.write(out, "v0", v0);
		Record.write(out, "v1", v1);
		Record.write(out, "label", label);
	}
	public void load(BufferedReader in){
		v0 = Record.read_Vector2D(in);
		v1 = Record.read_Vector2D(in);
		label = Record.read_String(in);
	}
	
	
	public String get_default_name(){
		return "gap"+id;
	}

	
	double d = 10;
	public void paint(Graphics g){
		
		if (Vector2D.distance(v0, v1)==0)
			return;
		
		g.setColor(Color.black);
		
		drawLine(g, v0, v1);

		paint_arrowhead(g, v0, v1, d);
		paint_arrowhead(g, v1, v0, d);

		/*
		Vector2D x_vec = new Vector2D(v0, v1);
		x_vec.normalize();
		x_vec.multiply(d);
		Vector2D y_vec = Vector2D.rotate90(x_vec);
		drawLine(g, v0, Vector2D.add(v0, x_vec, y_vec));
		drawLine(g, v0, Vector2D.add(v0, x_vec, Vector2D.multiply(y_vec,-1)));

		drawLine(g, v1, Vector2D.add(v1, Vector2D.multiply(x_vec,-1), y_vec));
		drawLine(g, v1, Vector2D.add(v1, Vector2D.multiply(x_vec,-1), Vector2D.multiply(y_vec,-1)));
		*/
		
		Vector2D center = Vector2D.mid_point(v0,  v1);
//		g.setColor(Color.white);
//		g.drawString(label, (int)center.x-5-2, (int)center.y+10);
//		g.drawString(label, (int)center.x-5+2, (int)center.y+10);
//		g.drawString(label, (int)center.x-5, (int)center.y+10-2);
//		g.drawString(label, (int)center.x-5, (int)center.y+10+2);
//		g.setColor(Color.black);
		drawString(g, label, (int)center.x+5, (int)center.y-5);
	}

	
	public void paint_bbox(Graphics g){
		g.setColor(Color.red);
		
		Vector2D x_vec = new Vector2D(v0, v1);
		x_vec.normalize();
		Vector2D y_vec = Vector2D.rotate90(x_vec);
		x_vec.multiply(3);
		y_vec.multiply(d+3);
		
		Vector2D c0 = Vector2D.subtract(Vector2D.subtract(v0,  x_vec), y_vec);
		Vector2D c1 = Vector2D.add(Vector2D.subtract(v0,  x_vec), y_vec);
		Vector2D c2 = Vector2D.add(Vector2D.add(v1,  x_vec), y_vec);
		Vector2D c3 = Vector2D.subtract(Vector2D.add(v1,  x_vec), y_vec);
		drawLine(g, c0, c1);
		drawLine(g, c1, c2);
		drawLine(g, c2, c3);
		drawLine(g, c3, c0);
		
	}
	
	public void set_label(String typed){
		int code = (int)typed.charAt(0);
		if (code == 8 || code == 127){
			if (label.length()>0)
				label = label.substring(0, label.length()-1);
		}
		else
			label += typed;
	}
	
}
