package physics;

import java.awt.*;
import java.awt.event.*;

import javax.swing.*;
import javax.swing.event.*;

import java.util.*;

public class ToolPanel extends JPanel{

	public ToolPanel(){
		setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
		setBackground(Color.lightGray);
		add(new MyToggleButton("Select"));
		add(new MyToggleButton("Line"));
		add(new MyToggleButton("Spring"));
		add(new MyToggleButton("Wall"));
		add(new MyToggleButton("Stick"));
		add(new MyToggleButton("Mass"));
		add(new MyToggleButton("Finger"));
		add(new MyToggleButton("Pulley"));
		add(new MyToggleButton("Fixpoint"));
		add(new MyToggleButton("Arrow"));
		add(new MyToggleButton("Tag"));
		add(new MyToggleButton("Gap"));
		add(new MyToggleButton("Arc"));
	}
	public ArrayList<MyToggleButton> toggle_buttons = new ArrayList();
	void update_toggle_buttons(String label){
		for(MyToggleButton toggle_button : toggle_buttons){
			if (!toggle_button.getLabel().equals(label)){
				toggle_button.setSelected(false);
			}
		}
	}

	public void buttonPressed(String name) {
		if (name.equals("Select")){
			MainPanel.mainPanel.current_tool = new SelectTool();
		}
		if (name.equals("Stick")){
			MainPanel.mainPanel.current_tool = new DrawStick();
		}
		if (name.equals("Wall")){
			MainPanel.mainPanel.current_tool = new DrawWall();
		}
		if (name.equals("Finger")){
			MainPanel.mainPanel.current_tool = new DrawFinger();
		}
		if (name.equals("Line")){
			MainPanel.mainPanel.current_tool = new DrawWire();
		}
		if (name.equals("Mass")){
			MainPanel.mainPanel.current_tool = new DrawMass();
		}
		if (name.equals("Spring")){
			MainPanel.mainPanel.current_tool = new DrawSpring();
		}
		if (name.equals("Pulley")){
			MainPanel.mainPanel.current_tool = new DrawPulley();
		}
		if (name.equals("Fixpoint")){
			MainPanel.mainPanel.current_tool = new DrawFixpoint();
		}
		if (name.equals("Arrow")){
			MainPanel.mainPanel.current_tool = new DrawArrow();
		}
		if (name.equals("Gap")){
			MainPanel.mainPanel.current_tool = new DrawGap();
		}
		if (name.equals("Arc")){
			MainPanel.mainPanel.current_tool = new DrawArc();
		}
		if (name.equals("Tag")){
			MainPanel.mainPanel.current_tool = new DrawTag();
		}
	}
	class MyToggleButton extends JToggleButton {
		MyToggleButton(String label) {
			super(label);
			setFont(Buttons.font);
			setSize(new Dimension(200,100));
			setLabel(label);
			addMouseListener(new MouseAdapter() {
				public void mouseReleased(MouseEvent e) {
					buttonPressed(getLabel());
					
					update_toggle_buttons(getLabel());
				}
			});
			toggle_buttons.add(this);
		}
	}
	class MyButton extends Button {
		MyButton(String label) {
			setFont(Buttons.font);
			setLabel(label);
			addMouseListener(new MouseAdapter() {
				public void mouseReleased(MouseEvent e) {
					buttonPressed(getLabel());
				}
			});
		}

	}
}
