package physics;

import java.awt.*;
import java.io.*;
import java.util.ArrayList;

public class Visual {
	public int id;
	static int global_id=0;
	public Visual(){
		id = global_id++;
		set_default_properties();
	}
	
	public void save(BufferedWriter out){}
	public void load(BufferedReader in){}
	
	
	public void start_dragging(Vector2D p){
		
	}
	public void dragging(Vector2D p){
		
	}
	public void finish_dragging(){
	}
	
	
	
	public void paint(Graphics g){
		
	}
	public void paint_bbox(Graphics g){
		
	}
	void drawString(Graphics g, String label, int x, int y){
		g.setColor(Color.white);
		g.drawString(label, x-2, y);
		g.drawString(label, x+2, y);
		g.drawString(label, x, y-2);
		g.drawString(label, x, y+2);
		g.drawString(label, x-2, y-2);
		g.drawString(label, x-2, y+2);
		g.drawString(label, x+2, y-2);
		g.drawString(label, x+2, y+2);
		g.setColor(Color.black);
		g.drawString(label, x, y);
	}

	public double get_distance(Vector2D v){
		return Double.MAX_VALUE;
	}
	public double get_distance_endpoint(Vector2D v){
		return Double.MAX_VALUE;
	}
	public String get_default_name(){
		return "";
	}
	public String get_name(){
		return "";
	}

	ArrayList<String> tags = new ArrayList();
	
	public void set_label(String label){
		
	}
	public ArrayList<Node> get_nodes(){
		return new ArrayList();
	}
	
	public void println(Graphics g, String line, Point offset){
		g.setColor(Color.black);
		g.drawString(line, offset.x, offset.y+15);
		offset.y+=30;
	}
	static public void drawLine(Graphics g,Vector2D p, Vector2D q){
		g.drawLine((int)p.x, (int)p.y, (int)q.x, (int)q.y);

	}


	public String label="";
	public ArrayList<Property> properties = new ArrayList();
	public void set_default_properties(){
		properties.clear();
	}
	
	public void set_property(String property_name, String value, boolean constant, boolean positive){
		Property property = null;
		for(Property _property : properties){
			if (_property.name.equals(property_name)){
				_property.name = property_name;
				_property.label = value;
				_property.constant = constant;
				_property.positive = positive;
				return;
			}
		}
		if (property == null){
			properties.add(new Property(property_name, value, constant, positive));
		}
	}
	
	
	
	public void set_property(String property_name, String value){
		Property property = null;
		for(Property _property : properties){
			if (_property.name.equals(property_name)){
				_property.name = property_name;
				_property.label = value;
				return;
			}
		}
		if (property == null){
			//properties.add(new Property(property_name, value, true, false));
			add_new_property(property_name, value);
		}
	}
	public void add_new_property(String property_name, String value){
		boolean constant = false;
		boolean positive = false;
		
		if (property_name.equals("angle"))
			constant = false;//true;	ׂēƂė^
		if (property_name.equals("acceleration"))
			constant = false;
		if (property_name.equals("eom"))
			constant = false;
		
		
		properties.add(new Property(property_name, value, constant, positive));

	}
	
	
	/*
	public void set_property(String property_name, String value){
		Property property = null;
		for(Property _property : properties){
			if (_property.name.equals(property_name)){
				_property.name = property_name;
				_property.label = value;
				return;
			}
		}
		if (property == null){
			properties.add(new Property(property_name, value, true));
		}
	}
	*/
	public String get_property_name_and_value(String property_name){
		return property_name+"("+get_property_value(property_name)+")";
	}
	public String get_property_value(String property_name){
		for(Property _property : properties){
			if (_property.name.equals(property_name)){
				return _property.label;
			}
		}
		return null;
	}
	public String get_variable(String property_name){
		if (property_name.equals("0"))
				return "0";

		String property_value = get_property_value(property_name);
		
		if (property_value == null){
			property_value = property_name + id;
			
			/*
			boolean constant = false;
			boolean positive = false;
			
			if (property_name.equals("angle"))
				constant = true;
			
			set_property(property_name, property_value, constant, positive);
			*/
			
			add_new_property(property_name, property_value);
		}

		return property_value;
	}
	
	
	
	
	public Property get_property(String property_name){
		for(Property _property : properties){
			if (_property.name.equals(property_name)){
				return _property;
			}
		}
		return null;
	}
	
	public String solve(String property_name){
		return "error";
	}
	public ArrayList<String> get_equations(){
		return new ArrayList();
	}
	public ArrayList<String> get_free_variables(){
		return new ArrayList<String>();
	}
	/*
	static public String round(double x){
		if (Math.abs(x) < 0.00001)
			return "0";
		if (Math.abs(x-1) < 0.00001)
			return "1";
		if (Math.abs(x+1) < 0.00001)
			return "(-1)";
		double y =((int)(x*10))/10.0;
		if (y>0)
			return ""+y;
		else
			return "("+y+")";
	}
	*/
	static public String negate(String value){
		if (value.charAt(0)=='-')
			return value.substring(1, value.length());
		else 
			return "(-"+value+")";
		
	}
	
	
	
	public void paint_rotated_rectangle(Graphics g, Vector2D v0, Vector2D v1, double width){
		g.setColor(Color.black);
		
		Vector2D vec = new Vector2D(v0, v1);
		vec.normalize();
		vec.multiply(width/2);
		vec = Vector2D.rotate90(vec);
		
		Vector2D c0 = Vector2D.subtract(v0, vec);
		Vector2D c1 = Vector2D.add(v0, vec);
		Vector2D c2 = Vector2D.add(v1, vec);
		Vector2D c3 = Vector2D.subtract(v1, vec);
		drawLine(g, c0, c1);
		drawLine(g, c1, c2);
		drawLine(g, c2, c3);
		drawLine(g, c3, c0);
	}
	
	public boolean contains_tag(String _tag){
		for(String tag : tags){
			if (tag.equals(_tag))
				return true;
		}
		return false;
	}
}

