package physics;

import java.awt.Color;
import java.awt.Graphics;
import java.util.ArrayList;

public class Wall extends EdgeVisual {
	public Wall(){
		super();

	}
	public Wall(Vector2D v0, Vector2D v1){
		super(v0, v1);

	}
	double d = 20;

	public String get_default_name(){
		return "wall"+id;
	}

	public void paint(Graphics g){
		g.setColor(Color.black);
		g.drawLine((int)v0.x, (int)v0.y, (int)v1.x, (int)v1.y);
		

		double l = Vector2D.distance(v0, v1);
		Vector2D x_vec = new Vector2D(v0, v1);
		x_vec.normalize();
		x_vec.multiply(d);
		Vector2D y_vec = Vector2D.rotate90(x_vec);
		for(int i=0; i<l/d-1; i++){
			Vector2D p = Vector2D.add(v0, Vector2D.multiply(x_vec,  i+0.5));
			Vector2D q = Vector2D.add(p, x_vec, y_vec);
			g.drawLine((int)p.x, (int)p.y, (int)q.x, (int)q.y);
		}
	}
	public void paint_bbox(Graphics g){
		g.setColor(Color.red);
		
		Vector2D x_vec = new Vector2D(v0, v1);
		x_vec.normalize();
		Vector2D y_vec = Vector2D.rotate90(x_vec);
		x_vec.multiply(3);
		Vector2D y_vec0 = Vector2D.multiply(y_vec, 3);
		Vector2D y_vec1 = Vector2D.multiply(y_vec, d+3);
		
		Vector2D c0 = Vector2D.subtract(Vector2D.subtract(v0,  x_vec), y_vec0);
		Vector2D c1 = Vector2D.add(Vector2D.subtract(v0,  x_vec), y_vec1);
		Vector2D c2 = Vector2D.add(Vector2D.add(v1,  x_vec), y_vec1);
		Vector2D c3 = Vector2D.subtract(Vector2D.add(v1,  x_vec), y_vec0);
		drawLine(g, c0, c1);
		drawLine(g, c1, c2);
		drawLine(g, c2, c3);
		drawLine(g, c3, c0);
		
	}
	
	int node_index = 0;
	public void clear_nodes(){
		node_index = 0;
	}
	public Node get_node(Vector2D position){
		node_index ++;
		
		/*
		 ȉ͖_𗧂ĂĂꍇ̂߁B@olԂ牺ĂꍇɂȂ̂ŗvC
		if (this.get_property("sfc") != null){	// set sfc of wall is 0
			if (v0.x == v1.x){
				Node node = new Node(this,  "reaction", "0", position, "id"+id);
				node.acceleration_x = "0";
				node.acceleration_y = "0";
				return node;
			}
			else if (v0.y == v1.y){
				Node node = new Node(this,  "0", "reaction", position, "id"+id);
				node.acceleration_x = "0";
				node.acceleration_y = "0";
				return node;
			}
		}
		
		if (node_index == 1){
			if (v0.x == v1.x){
				Node node = new Node(this,  "reaction", get_variable("friction_force"), position, "id"+id);
				node.acceleration_x = "0";
				node.acceleration_y = "0";
				return node;
			}
			else if (v0.y == v1.y){
				Node node = new Node(this,  get_variable("friction_force"), "reaction", position, "id"+id);
				node.acceleration_x = "0";
				node.acceleration_y = "0";
				return node;
			}
			
			Node node = new Node(this,  "reaction", "reaction", position, "id"+id);
			node.acceleration_x = "0";
			node.acceleration_y = "0";
			return node;
		}
*/		
		Node node = new Node(this,  "reaction", "reaction", position, "id"+id);
		node.acceleration_x = "0";
		node.acceleration_y = "0";
		return node;
	}
	
}
