package physics;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.Point;
import java.util.ArrayList;

public class Wire extends EdgeVisual {
	public Wire(){
		super();

	}
	public Wire(Vector2D v0, Vector2D v1){
		super(v0, v1);

	}
	public void set_default_properties(){
		properties.clear();
		set_property("tensforce", "T"+id, false, true);
	}
		
	public String get_default_name(){
		return "line"+id;
	}
	public String get_name(){
		return "line";
	}

	
	
	

	public void paint(Graphics g){
		g.setColor(Color.black);
		g.drawLine((int)v0.x, (int)v0.y, (int)v1.x, (int)v1.y);
	}
	public void paint_bbox(Graphics g){
		g.setColor(Color.red);
		
		Vector2D x_vec = new Vector2D(v0, v1);
		x_vec.normalize();
		Vector2D y_vec = Vector2D.rotate90(x_vec);
		x_vec.multiply(3);
		y_vec.multiply(3);
		
		Vector2D c0 = Vector2D.subtract(Vector2D.subtract(v0,  x_vec), y_vec);
		Vector2D c1 = Vector2D.add(Vector2D.subtract(v0,  x_vec), y_vec);
		Vector2D c2 = Vector2D.add(Vector2D.add(v1,  x_vec), y_vec);
		Vector2D c3 = Vector2D.subtract(Vector2D.add(v1,  x_vec), y_vec);
		drawLine(g, c0, c1);
		drawLine(g, c1, c2);
		drawLine(g, c2, c3);
		drawLine(g, c3, c0);
		
	}
	
	
	
	/*
	public void set_default_angle(){
		Vector2D direction = new Vector2D(v0, v1);
		direction.normalize();
		
	
		angle_x = "("+direction.x+")";
		angle_y = "("+direction.y+")";
		
	}	
*/
	
	public ArrayList<Node> get_nodes(){

		
		
		ArrayList<Node> nodes = new ArrayList();
		Node node0 = new Node(this, get_variable("tensforce")+ " * "+vec_x(v0), get_variable("tensforce")+ " * "+vec_y(v0), v0, "ep1(id"+id+")");
		Node node1 = new Node(this, get_variable("tensforce")+ " * "+vec_x(v1), get_variable("tensforce")+ " * "+vec_y(v1), v1, "ep2(id"+id+")");
		
		if (Acceleration.enabled){
			node0.acceleration_x = get_variable("acceleration_x");
			node0.acceleration_y = get_variable("acceleration_y");

			node1.acceleration_x = get_variable("acceleration_x");
			node1.acceleration_y = get_variable("acceleration_y");
			
			//node0.acceleration_x = get_variable("acceleration") + " * " + this.vec_x() ;
			//node0.acceleration_y = get_variable("acceleration") + " * " + this.vec_y() ;

			//node1.acceleration_x = get_variable("acceleration") + " * " + this.vec_x() ;
			//node1.acceleration_y = get_variable("acceleration") + " * " + this.vec_y() ;

		}
		
		
		nodes.add(node0);
		nodes.add(node1);
		
		return nodes;

	}

	
	
	public ArrayList<String> get_free_variables(){
		ArrayList<String> variables = new ArrayList();
		variables.add(get_variable("tensforce"));
		return variables;
	}


	
}
